#include "jngen.h"
#include <iostream>
#include <array>

using std::cout;

std::array<int, 8> n_bounds{{
    -1, // dummy value for group 0
    100,
    1'000,
    100'000,
    100'000, // group 4 is supported here
    100'000,
    40'000,
    100'000
}};

const int MAX_H_3 = 10;
const int MAX_H = 1'000'000'000;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    int group = getOpt("g");
    int n = getOpt("n", n_bounds[group]);
    int middle_center = getOpt("mid", 0);

    int max_h = (group == 3) ? MAX_H_3 : MAX_H;
    max_h = getOpt("h", max_h);

    auto h = Array::random(n, 1, max_h);

    // Making bitonic
    int mid = rnd.wnext(n, middle_center);
    std::sort(h.begin(), h.begin() + mid);
    std::reverse(h.begin(), h.begin() + mid);
    std::sort(h.begin() + mid, h.end());

    cout << n << "\n";
    cout << h << "\n";

    for (int i = 1; i < n; i++) {
        int l = rnd.next(1, n - i);
        if (group == 5) {
            l = 1;
        }
        cout << l;
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    return 0;
}
