#include "jngen.h"
#include <iostream>
#include <array>

using std::cout;

std::array<int, 8> n_bounds{{
    -1, // dummy value for group 0
    100,
    1'000,
    100'000,
    -1, // group 4 is not supported here
    100'000,
    40'000,
    100'000
}};

const int MAX_H_3 = 10;
const int MAX_H = 1'000'000'000;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    int group = getOpt("g");
    int n = getOpt("n", n_bounds[group]);

    int max_h = (group == 3) ? MAX_H_3 : MAX_H;
    max_h = getOpt("h", max_h);

    int pref = getOpt("l", 1);
    int suff = getOpt("r", 1);

    auto h = Array::random(n, 1, max_h);

    cout << n << "\n";
    cout << h << "\n";

    for (int i = 1; i < n; i++) {
        int l;
        if (rnd.next(pref + suff) < pref) {
            l = 1;
        } else {
            l = n - i;
        }
        cout << l;
        if (i + 1 == n) {
            cout << "\n";
        } else {
            cout << " ";
        }
    }
    return 0;
}
