#include "testlib.h"

using namespace std;

const std::string YES = "yes";
const std::string NO = "no";

bool check(InStream& in, int n, int sum, const vector<vector<int>>& a) {
    auto res = lowerCase(in.readString("[a-zA-Z]{2,3}", "yesno_token"));
    if (res == NO) {
        return false;
    }
    if (res != YES) {
        in.quitf(_wa, "Unexpected token %s, Yes/No expected", res.c_str());
    }
    
    int curSum = 0;
    for (int i = 0; i < n; i++) {
        int k = in.readInt(1, (int)a[i].size(), "m_i");
        vector<bool> used(a[i].size());
        for (int j = 0; j < k; j++) {
            int ind = in.readInt(1, (int)a[i].size(), "number_ij");
            if (used[ind - 1]) {
                in.quitf(_wa, "Duplicate subtask index %d in task %d", ind, i + 1);
            }
            used[ind - 1] = true;
            curSum += a[i][ind - 1];
        }
    }
    
    if (curSum != sum) {
        in.quitf(_wa, "Invalid sum (expected %d, found %d)", sum, curSum);
    }
    return true;
}


int main(int argc, char* argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int sum = inf.readInt();

    vector<vector<int>> a(n);

    for (int i = 0; i < n; i++) {
        int k = inf.readInt();
        a[i] = inf.readInts(k);
    }

    bool pAns = check(ouf, n, sum, a);
    bool jAns = check(ans, n, sum, a);
    if (pAns == jAns) {
        quitf(_ok, "OK");
    }
    if (pAns && !jAns) {
        quitf(_fail, "Participant has answer, jury hasn't answer");
    } else {
        quitf(_wa, "Jury has answer, participant hasn't answer");
    }
    return 0;
}
