// #pragma comment(linker, "/stack:200000000")
// #pragma GCC optimize("Ofast,no-stack-protector")
// #pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
// #pragma GCC optimize("unroll-loops")

#include <stdio.h>
#include <bits/stdc++.h>

#ifdef PERVEEVM_LOCAL
    #define debug(x...) std::cerr << "[DEBUG]\t" << __LINE__ << ":\t" << (#x) << " = "; print_debug(x)
#else
    #define debug(x...) 238
#endif

#define fastIO std::ios_base::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(nullptr)
#define NAME "File"

using ll = long long;
using ld = long double;

#ifdef PERVEEVM_LOCAL
    std::mt19937 rnd(238);
#else
    std::mt19937 rnd(std::chrono::high_resolution_clock::now().time_since_epoch().count());
#endif

template<typename T1, typename T2>
std::ostream& operator<<(std::ostream& out, const std::pair<T1, T2>& p) {
    out << "(" << p.first << ", " << p.second << ")";
    return out;
}

template<size_t index, typename T>
std::ostream& print_tuple(std::ostream& out, const T& t) {
    if constexpr (index == std::tuple_size<T>::value) {
        out << ")";
        return out;
    } else {
        if (index > 0) {
            out << ", ";
        } else {
            out << "(";
        }
        out << std::get<index>(t);
        return print_tuple<index + 1, T>(out, t);
    }
}

template<typename ...T>
std::ostream& operator<<(std::ostream& out, const std::tuple<T...>& t) {
    return print_tuple<0, std::tuple<T...>>(out, t);
}

template<typename Container, typename = decltype(std::begin(std::declval<Container>()))>
typename std::enable_if<!std::is_same<Container, std::string>::value, std::ostream&>::type
operator<<(std::ostream& out, const Container& container) {
    out << "{";
    for (auto it = container.begin(); it != container.end(); ++it) {
        if (it != container.begin()) {
            out << ", ";
        }
        out << *it;
    }
    out << "}";
    return out;
}

void print_debug() {
    std::cerr << std::endl;
}

template<typename T, typename... V>
void print_debug(const T& value, const V&... others) {
    std::cerr << value;
    if (sizeof...(others) != 0) {
        std::cerr << ", ";
        print_debug(others...);
    } else {
        std::cerr << std::endl;
    }
}

template<typename T>
bool smin(T& a, const T& b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool smax(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

const double PI = atan2(0.0, -1.0);
const int INF = 0x3f3f3f3f;
const ll LINF = (ll)2e18;
const int N = 100100;

std::vector<int> a[N];
int allScores[N];
std::pair<int, int> initialIndex[N];
bool isFinishScore[N];

void run() {
    int n, s;
    scanf("%d%d", &n, &s);

    int all = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        scanf("%d", &k);

        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            scanf("%d", &a[i][j]);
            allScores[all] = a[i][j];
            initialIndex[all] = std::make_pair(i, j);
            ++all;
        }
        isFinishScore[all - 1] = true;
    }

    std::vector<std::vector<std::array<bool, 2>>> dp(all + 1, std::vector<std::array<bool, 2>>(s + 1, {false, false}));
    dp[0][0][0] = true;
    for (int i = 0; i < all; ++i) {
        int score = allScores[i];
        if (isFinishScore[i]) {
            // take
            for (int j = 0; j <= s - score; ++j) {
                dp[i + 1][j + score][0] |= dp[i][j][0];
                dp[i + 1][j + score][0] |= dp[i][j][1];
            }
            // don't take
            for (int j = 0; j <= s; ++j) {
                dp[i + 1][j][0] |= dp[i][j][1];
            }
        } else {
            // take
            for (int j = 0; j <= s - score; ++j) {
                dp[i + 1][j + score][1] |= dp[i][j][0];
                dp[i + 1][j + score][1] |= dp[i][j][1];
            }
            // don't take
            for (int j = 0; j <= s; ++j) {
                dp[i + 1][j][0] |= dp[i][j][0];
                dp[i + 1][j][1] |= dp[i][j][1];
            }
        }
    }

    if (!dp[all][s][0]) {
        printf("No\n");
        return;
    }

    std::vector<std::vector<int>> ans(n);
    int i = all;
    int j = s;
    int state = 0;
    while (i != 0) {
        int score = allScores[i - 1];
        if (isFinishScore[i - 1]) {
            assert(state == 0);
            if (dp[i - 1][j][1]) {
                --i;
                state = 1;
            } else {
                auto[pi, pj] = initialIndex[i - 1];
                ans[pi].push_back(pj);
                if (dp[i - 1][j - score][0]) {
                    --i;
                    j -= score;
                    state = 0;
                } else {
                    assert(dp[i - 1][j - score][1]);
                    --i;
                    j -= score;
                    state = 1;
                }
            }
        } else {
            if (dp[i - 1][j][state]) {
                --i;
            } else {
                assert(state == 1);
                auto[pi, pj] = initialIndex[i - 1];
                ans[pi].push_back(pj);
                if (dp[i - 1][j - score][0]) {
                    --i;
                    j -= score;
                    state = 0;
                } else {
                    assert(dp[i - 1][j - score][1]);
                    --i;
                    j -= score;
                    state = 1;
                }
            }
        }
    }

    printf("Yes\n");
    for (int it = 0; it < n; ++it) {
        printf("%d\n", (int)ans[it].size());
        for (auto v : ans[it]) {
            printf("%d ", v + 1);
        }
        printf("\n");
    }
}

int main(void) {
    // freopen(NAME".in", "r", stdin);
    // freopen(NAME".out", "w", stdout);

    #ifdef PERVEEVM_LOCAL
        auto start = std::chrono::high_resolution_clock::now();
    #endif

    run();

    #ifdef PERVEEVM_LOCAL
        auto end = std::chrono::high_resolution_clock::now();
        std::cerr << "Execution time: "
                  << std::chrono::duration_cast<std::chrono::milliseconds>(end - start).count()
                  << " ms" << std::endl;
    #endif

    return 0;
}
