#include <bits/stdc++.h>

using namespace std;

constexpr int MOD = 1'000'000'007;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    if (n >= 10 || m >= 10) {
        cout << -1 << '\n';  // do not want to kill polygon
        return 0;
    }

    using pi = pair<int, int>;
    vector<pi> pts(k);
    for (auto& [x, y] : pts) {
        cin >> x >> y;
    }

    long long ans = 0;

    const int half = n + m - 2;
    for (int P = 0; P < (1 << half); ++P) {
        for (int Q = 0; Q < (1 << half); ++Q) {
            vector<pi> cycle;
            int cx = 1, cy = 1;

            for (int i = 0; i < half; ++i) {
                if ((P >> i) & 1) {
                    cx++;
                } else {
                    cy++;
                }
                cycle.emplace_back(cx, cy);
            }

            if (cx != n && cy != m) {
                continue;
            }

            for (int i = 0; i < half; ++i) {
                if ((Q >> i) & 1) {
                    cx--;
                } else {
                    cy--;
                }
                cycle.emplace_back(cx, cy);
            }

            if (cx != 1 && cy != 1) {
                continue;
            }

            bool ok = true;
            for (int i = 0; i < (int)cycle.size(); ++i) {
                for (int j = 0; j < i; ++j) {
                    if (cycle[i] == cycle[j]) {
                        ok = false;
                    }
                }
            }

            for (auto pt : pts) {
                bool found = false;
                for (auto x : cycle) {
                    if (pt == x) {
                        found = true;
                    }
                }
                if (!found) {
                    ok = false;
                }
            }
            
            if (ok) {
                ans += 1;
            }
        }
    }

    cout << ans % MOD << '\n';
}